/*
 * Copyright (c) 2001 Conexant Systems, Inc.
 * 
 * 1.   Permitted use. Redistribution and use in source and binary forms,
 * with or without modification, are permitted under the terms set forth
 * herein.
 * 
 * 2.   Disclaimer of Warranties. CONEXANT AND OTHER CONTRIBUTORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.
 * IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTIES OF ANY KIND.
 * CONEXANT AND OTHER CONTRIBUTORS DISCLAIMS ALL WARRANTIES WITH REGARD TO
 * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, GOOD TITLE AND AGAINST INFRINGEMENT.
 * 
 * This software has not been formally tested, and there is no guarantee that
 * it is free of errors including, but not limited to, bugs, defects,
 * interrupted operation, or unexpected results. Any use of this software is
 * at user's own risk.
 * 
 * 3.   No Liability.
 * 
 * (a) Conexant or contributors shall not be responsible for any loss or
 * damage to Company, its customers, or any third parties for any reason
 * whatsoever, and CONEXANT OR CONTRIBUTORS SHALL NOT BE LIABLE FOR ANY
 * ACTUAL, DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR OTHER LEGAL THEORY OF
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
 * WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 * 
 * (b) User agrees to hold Conexant and contributors harmless from any
 * liability, loss, cost, damage or expense, including attorney's fees,
 * as a result of any claims which may be made by any person, including
 * but not limited to User, its agents and employees, its customers, or
 * any third parties that arise out of or result from the manufacture,
 * delivery, actual or alleged ownership, performance, use, operation
 * or possession of the software furnished hereunder, whether such claims
 * are based on negligence, breach of contract, absolute liability or any
 * other legal theory.
 * 
 * 4.   Notices. User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential
 * legends placed upon, contained within or associated with the Software,
 * and shall include all such unaltered copyright, trademark, credits,
 * other proprietary notices or confidential legends on or in every copy of
 * the Software.
 * 
 */
#include "oscompat.h"
#include "ossysenv.h"

#include "ostime_ex.h"
#include "osmemory_ex.h"
#include "osstring_ex.h"
#include "osnvm.h"
#include "osmodule.h"
#include "osstdio.h"
#ifdef SCR
#include "cdbgscr_ex.h"
#endif
#include "linuxres.h"
#include "oscompat.h"

/** linuxres.c **/
EXPORT_SYMBOL_NOVERS(LinuxGetHwPciRes);
EXPORT_SYMBOL_NOVERS(LinuxInitPowerManagement);
EXPORT_SYMBOL_NOVERS(LinuxTermPowerManagement);
EXPORT_SYMBOL_NOVERS(LinuxHookInterrupt);
EXPORT_SYMBOL_NOVERS(LinuxUnhookInterrupt);
EXPORT_SYMBOL_NOVERS(LinuxMapPhys);
EXPORT_SYMBOL_NOVERS(LinuxReadw);
EXPORT_SYMBOL_NOVERS(LinuxReadl);
EXPORT_SYMBOL_NOVERS(LinuxWritew);
EXPORT_SYMBOL_NOVERS(LinuxWritel);
EXPORT_SYMBOL_NOVERS(LinuxIoReadb);
EXPORT_SYMBOL_NOVERS(LinuxIoReadw);
EXPORT_SYMBOL_NOVERS(LinuxIoReadl);
EXPORT_SYMBOL_NOVERS(LinuxIoWriteb);
EXPORT_SYMBOL_NOVERS(LinuxIoWritew);
EXPORT_SYMBOL_NOVERS(LinuxIoWritel);
EXPORT_SYMBOL_NOVERS(LinuxPciReadConfigdw);
EXPORT_SYMBOL_NOVERS(LinuxPciReadConfigw);
EXPORT_SYMBOL_NOVERS(LinuxPciReadConfigb);
EXPORT_SYMBOL_NOVERS(LinuxPciWriteConfigdw);
EXPORT_SYMBOL_NOVERS(LinuxPciWriteConfigw);
EXPORT_SYMBOL_NOVERS(LinuxPciWriteConfigb);
EXPORT_SYMBOL_NOVERS(crit_section_start);
EXPORT_SYMBOL_NOVERS(crit_section_end);
EXPORT_SYMBOL_NOVERS(LinuxCalcCpuRate);

#ifdef SCR
/** cdbgscr. **/
EXPORT_SYMBOL_NOVERS(C_ScrFormat);
EXPORT_SYMBOL_NOVERS(LinuxScrSetEntryPointCallback);
#endif

/** OsTime **/
EXPORT_SYMBOL_NOVERS(OsModemThreadSchedule);
EXPORT_SYMBOL_NOVERS(OSCreatePeriodicTimeOut);
EXPORT_SYMBOL_NOVERS(OSDestroyPeriodicTimeOut);
EXPORT_SYMBOL_NOVERS(OSSetPeriodicTimeOut);
EXPORT_SYMBOL_NOVERS(OSGetSystemTime);
EXPORT_SYMBOL_NOVERS(OSCreateTimer);
EXPORT_SYMBOL_NOVERS(OSSetTimer);
EXPORT_SYMBOL_NOVERS(OSCancelTimer);
EXPORT_SYMBOL_NOVERS(OSChangeTimerTimeOut);
EXPORT_SYMBOL_NOVERS(OSDestroyTimer);
EXPORT_SYMBOL_NOVERS(OSFloatSuffix);
EXPORT_SYMBOL_NOVERS(OSFloatPrefix);
EXPORT_SYMBOL_NOVERS(OSSemaphoreWait);
EXPORT_SYMBOL_NOVERS(OSSemaphoreSignal);
EXPORT_SYMBOL_NOVERS(OSSemaphoreCreate);
EXPORT_SYMBOL_NOVERS(OSSemaphoreDestroy);
EXPORT_SYMBOL_NOVERS(OSCriticalSectionDestroy);
EXPORT_SYMBOL_NOVERS(OSCriticalSectionAcquire);
EXPORT_SYMBOL_NOVERS(__OSCriticalSectionCreate);
EXPORT_SYMBOL_NOVERS(OSCriticalSectionRelease);
EXPORT_SYMBOL_NOVERS(OSRestoreTimeSensitivity);
//EXPORT_SYMBOL_NOVERS(OSDisableInterrupt);
//EXPORT_SYMBOL_NOVERS(OSRestoreInterrupts);
EXPORT_SYMBOL_NOVERS(OSSetTimeSensitivity);
EXPORT_SYMBOL_NOVERS(OsAtomicAdd);
EXPORT_SYMBOL_NOVERS(OsAtomicCompareAndSwap);
EXPORT_SYMBOL_NOVERS(OsSleep);

/** OSMemory **/
EXPORT_SYMBOL_NOVERS(OsPageReserve);
EXPORT_SYMBOL_NOVERS(OsPageFree);
EXPORT_SYMBOL_NOVERS(OsHeapAllocate);
EXPORT_SYMBOL_NOVERS(OsHeapFree);
EXPORT_SYMBOL_NOVERS(OsGetPageSize);
EXPORT_SYMBOL_NOVERS(OsMemDMAAllocate);
EXPORT_SYMBOL_NOVERS(OsMemDMAFree);

/** OsString **/
EXPORT_SYMBOL_NOVERS(OsStrCpy);
EXPORT_SYMBOL_NOVERS(OsStrnCpy);
EXPORT_SYMBOL_NOVERS(OsStrCat);
EXPORT_SYMBOL_NOVERS(OsStrnCat);
EXPORT_SYMBOL_NOVERS(OsStrCmp);
EXPORT_SYMBOL_NOVERS(OsStrnCmp);
EXPORT_SYMBOL_NOVERS(OsToupper);
EXPORT_SYMBOL_NOVERS(OsTolower);
EXPORT_SYMBOL_NOVERS(OsIsDigit);
EXPORT_SYMBOL_NOVERS(OsSprintf);
EXPORT_SYMBOL_NOVERS(OSSprintfFixedArgs);
EXPORT_SYMBOL_NOVERS(OsStrLen);
EXPORT_SYMBOL_NOVERS(Osatoi);
EXPORT_SYMBOL_NOVERS(OsMemSet);
EXPORT_SYMBOL_NOVERS(OsMemCpy);
EXPORT_SYMBOL_NOVERS(OsMemCmp);
EXPORT_SYMBOL_NOVERS(OsMemMove);

/** OsDebug **/
EXPORT_SYMBOL_NOVERS(OsErrorVPrintf);
EXPORT_SYMBOL_NOVERS(OsErrorPrintf);
EXPORT_SYMBOL_NOVERS(OsDebugVPrintf);
EXPORT_SYMBOL_NOVERS(OsDebugPrintf);
EXPORT_SYMBOL_NOVERS(OsDebugBreakpoint);
EXPORT_SYMBOL_NOVERS(OsDebugDumpData);

/** OsModule **/
EXPORT_SYMBOL_NOVERS(OsModuleSymGet);
EXPORT_SYMBOL_NOVERS(OsModuleSymPut);

/** OsStdio **/
EXPORT_SYMBOL_NOVERS(OsFClose);
EXPORT_SYMBOL_NOVERS(OsFOpen);
EXPORT_SYMBOL_NOVERS(OsFRead);
EXPORT_SYMBOL_NOVERS(OsFWrite);
EXPORT_SYMBOL_NOVERS(OsFSeek);

/** OsNvm **/
EXPORT_SYMBOL_NOVERS(NVM_Open);
EXPORT_SYMBOL_NOVERS(NVM_Close);
EXPORT_SYMBOL_NOVERS(NVM_Read);
EXPORT_SYMBOL_NOVERS(NVM_Write);

MODULE_AUTHOR("Conexant Systems Inc.");
MODULE_DESCRIPTION("HSF softmodem driver");
MODULE_LICENSE("Copyright (C) 1996-2001 Conexant Systems Inc. All Rights Reserved.");


static int __init
hsfosspec_init(void)
{
	OSInitTime();

	return 0;
}

module_init(hsfosspec_init);
